#!/usr/bin/perl -w
use File::Basename;

# AddTrimBoxStd v1.0.4 beta ij΍eXgŁj
# DTPAvEPSprPDFɕϊƂ֗PerlXNvgłB
# ɏdvȎdオTCYقƂAŏtPDF܂B

#ygz
#	1.@EPS̃XNvgŏƐł̏tPSt@C܂B
#	2.@oPSt@CDistillerPDFɕϊĂB

#<< configuration----------------------------------------------------------------------------------------------------

$dft = -1 / 0.352778;  #(pt) ftHg-1
#		dオTCYȂEPSꍇɓKplłB
#		EPSŜ̃TCY(oEfBO{bNX)wlɓʒu
#		dオʒułƁuv邱Ƃł܂B
#		-(}CiX)lw肵Ƃ́AEPSɎdオTCYȂꍇ
#		ŗ]ƃg{͕tꂸAEPSŜdオTCYƍقƂɂȂ܂B
#		(PDFŜ̃Z^[ĂΖȂt[̕⏕)B

$bld = 3 / 0.352778;  #(pt) ftHg3mm (=8.503932pt)
#		قƂ(Bleed)̕łBdオʒűw肵ĂB

$slg = 20 / 0.352778;  #(pt) ftHg20mm (=56.692878pt)
#		ŗ]TCYłBdオ̊Oɗ]ǉ܂B
#		dオ肩̋Ȃ̂Ńu[hƓ傫lw肵ĂB

$tmb = 3;  #(0=off, 1=trim&bleed marks, 2=center marks, 3=all marks) ftHg3
#		dオʒuɂăg{`ł܂B
#		 : PDF/XɃg{͕K{ł͂܂B

##JX^}CY (IvV)
##
## mĂƕ֗ȋ@\łB
##
$crp = 0;  #(0=off, 1=TrimBox, 2=BleedBox) ftHg0
#		dオ̈(1)܂͍قƂ(2)̊OCropBoxɎw肵ă}XN܂B
#		Acrobat 7.0.0ł͍قƂʒu}XNPDF/XG[ɂȂ܂B
#		@قƂʒuBꍇقƂ͎dオʒuƓɂ܂B
#		 : PDF/Xłoff܂B

$rot = 0;  #(0, 90, 180, 270̂ꂩ) ftHg0
#		EPS荞ݎEPSuvv90xPʂŉ]ł܂B

$tit = "";  # ftHg""()
#		PDF̃^Cgw肷邱Ƃł܂B
#		ʏ͋󗓂ł܂܂B󗓂̏ꍇEPS^CgKp܂B
#		1bytegĂB

$aut = "";  # ftHg""()
#		PDFɐ҂̖Ow肷邱Ƃł܂(NCAg)B
#		ʏ͋󗓂ł܂܂B󗓂̏ꍇEPS쐬ҖKp܂B
#		1bytegĂB

$ext = "";  # ftHg""()
#		PostScriptt@C쐬tH_𖾎IɎw肷ꍇ̓tH_̃pXw肵ĂB
#		ʏ͋󗓂ł܂܂B󗓂̏ꍇEPSƓꏊPSt@C쐬܂B
#		sperlɂăpX̋Lq@ق܂B
#		windows ̏ꍇ̗@$ext = "C:/Documents and Settings/username/My Documents/distill/in/";
#		Mac OS X ̏ꍇ̗@$ext = "/Users/username/Desktop/distill/in/";
#		Mac OS 9 ̏ꍇ̗@$ext = "Macintosh HD:Users:username:Desktop:distill:in:";

#---------------------------------------------------------------------------------------------------- configuration >>

foreach $arg (@ARGV) {
	if($ext ne ""){
		($base, $dir) = fileparse($ext, '\.[^\.]+$');
		$ext = $dir.$base;
	}
	($base, $dir) = fileparse($arg, '\.[^\.]+$');
	if ($base =~ /(.+-\[)([+-]?\d+)(\]\D*)(\d+)-(\d+)/g){
		$base = sprintf("$1%03d-%03d]", int($2) + int($4) - 1,int($2) + int($5) - 1);
	}elsif($base =~ /(.+-\[)([+-]?\d+)(\]\D*)(\d+)/g){
		$base = sprintf("$1%03d-%03d]", int($2) + int($4) - 1, int($2) + int($4) - 1);
	}
	$newpath = $dir . '#' . $base . ".ps";
	if($ext ne ""){$newpath = $ext . '#' . $base . ".ps";}
	open(IN, "$arg") || die "can't open $arg \n";
	binmode(IN);

	# - PS data address check
	seek (IN,0,0); #TIFF preview
	if (( ord (getc IN) + ord (getc IN) * 0x100 ) == 53445 ) {
		$prv = 1;
		seek (IN,4,0); #PS start
		$psstrt = ord (getc IN) + ord (getc IN) * 0x100 + ord (getc IN) * 0x10000 + ord (getc IN) * 0x1000000;
		seek (IN,8,0); #PS size
		$pssiz = ord (getc IN) + ord (getc IN) * 0x100 + ord (getc IN) * 0x10000 + ord (getc IN) * 0x1000000;
	}else{
		$prv = 0;
		$psstrt = 0;
		$pssiz = (-s IN);
	}

	# - return code check
	$os = 0;
	seek (IN,$psstrt+23,0);
	$c = getc IN;
	if ($c eq chr (hex('0x0A'))) {
		$/ = pack ("C", hex("A"));
		$os = 1; # unix LF
	} elsif ($c eq chr (hex('0x0D'))) {
		$/ = pack("C", hex("D"));
		$os = 2; # mac CR
		if (getc IN eq chr (hex('0x0A'))) {
			$/ = pack("C", hex("A"));
			$os = 3; # win CR+LF
		}
	}

	# - search trim size
	if ($os != 0) {
		$lin = 0;
		$findtrim = 0;
		$ap = 0;
		$ai = 0;
		$come1 = "$/";
		$come2 = "$/";
		$come3 = "$/";
		$come4 = "$/";
		$trim = "%%BoundingBox:";
		seek (IN,$psstrt,0);
		while (<IN>) {
			if (($lin++ == 0) && (/^%\!PS-Adobe-.\.. EPSF/ eq '')) {
				last;
			}
			if (/^%%For:/){
				$come1=$_;
			}
			if (/^%%Creator:/){
				$come2=$_;
			}
			if (/^%%Title:/){
				$come3=$_;
			}
			if (/^%%CreationDate:/){
				$come4=$_;
			}
			if (/^%%Creator: EDICOLOR/) {
				$trim = "%%HiResBoundingBox:";
				$ap = 1;
			}
			if (/^%%Creator: Adobe Illustrator/) {
				$ai = 1;
			}
			if (/^%AI3_Cropmarks:/) {
				$trim = "%AI3_Cropmarks:";
				$ap = 1;
			}
			if (/^%%CropBox:/ && ($ap == 0) && ($ai == 0)) {
				$trim = "%%CropBox:";
				$ap = 1;
			}
			if (/^%%HiResBoundingBox:/ && ($ap == 0)) {
				$trim = "%%HiResBoundingBox:";
			}

			if (/^$trim ?(-?[\d\.]+) (-?[\d\.]+) (-?[\d\.]+) (-?[\d\.]+)/) {
				@TrimBoxH = ($1,$2,$3,$4);
				$findtrim = 1;
			}
			if (/%%EndComments/) {
				last;
			}
		}

		if ($findtrim == 1) {
			$trimsize = $dft; $cstbld=$bld;
			$cstmed=$slg; $addtmb=$tmb;
			if ($ap == 0) {
				if($dft < 0){$trimsize = 0; $cstbld=0; $cstmed=0; $addtmb=0;}
				$TrimBoxH[0] += $trimsize; $TrimBoxH[1] += $trimsize;
				$TrimBoxH[2] -= $trimsize; $TrimBoxH[3] -= $trimsize;
			}
			seek (IN,$psstrt,0);
			open(OUT, ">$newpath") || die "can't open $newpath \n";
			binmode(OUT);

			# - ps code write
			print OUT "%!PS-Adobe-3.1$/";
			print OUT $come2;
			if($aut eq ""){
				print OUT $come1;
			}else{
				print OUT "%%For: (",$aut,")$/";
			}
			if($tit eq ""){
				print OUT $come3;
			}else{
				print OUT "%%Title: (",$tit,")$/";
			}
			print OUT $come4;

			print OUT "%%Pages: 1$/";
			$width = $TrimBoxH[2]-$TrimBoxH[0]+$cstmed*2;
			$hight = $TrimBoxH[3]-$TrimBoxH[1]+$cstmed*2;
			if( ($rot == 90) or ($rot == 270) ) {
				$tmp=$width; $width=$hight; $hight=$tmp;
			}
			print OUT "%%BoundingBox: 0 0 ",int ($width+0.5)," ",int ($hight+0.5),"$/";# Half-adjust
			print OUT "%%HiResBoundingBox: 0 0 ",$width," ",$hight,"$/";
			print OUT "%%CropBox: ",$cstmed," ",$cstmed," ",$width-$cstmed," ",$hight-$cstmed,"$/";
			print OUT "%%DocumentSuppliedFeatures: *CustomPageSize True$/";
			print OUT "%%EndComments$/";
			print OUT "%%BeginDefaults$/";
			print OUT "%%ViewingOrientation: 1 0 0 1$/";
			print OUT "%%EndDefaults$/";

			print OUT "%%BeginProlog$/";
			# - flatness change (flatness 1)
			print OUT "	1 setflat /setflat{pop}bind def$/";
			# - avoid hasen monndai (Acrobat 6, Adobe CS series)
			print OUT "	/new_closepath /closepath load store /closepath{new_closepath 0 0 rlineto}bind def$/";
			print OUT "%%EndProlog$/";

			print OUT "%%BeginSetup$/";

			print OUT "%%BeginFeature: *CustomPageSize True$/";
			print OUT "<< /PageSize [",$width," ",$hight,"] /ImagingBBox null >> setpagedevice$/";
			print OUT "%%EndFeature$/";

			print OUT "%%EndSetup$/";

			print OUT "%%Page: 1 1$/";
			print OUT "%%EndPageComments$/";
			print OUT "%%BeginPageSetup$/";
			print OUT "%%EndPageSetup$/";

			print OUT "/showpage { } def$/";
			print OUT "0 setgray 0 setlinecap 1 setlinewidth 0 setlinejoin$/";
			print OUT "10 setmiterlimit [ ] 0 setdash newpath$/";
			print OUT "false setstrokeadjust false setoverprint$/"; 
			if( $rot ) {
				$tmp = int ($rot / 90 ) * 90;
				if ($tmp == 90) {print OUT $width," 0"," translate$/","90 rotate$/";}
				if ($tmp == 180) {print OUT $width," ",$hight," translate$/","180 rotate$/";}
				if ($tmp == 270) {print OUT "0 ",$hight," translate$/","270 rotate$/";}
			}
			print OUT $cstmed-$TrimBoxH[0]," ",$cstmed-$TrimBoxH[1]," translate$/";
			print OUT "gsave$/";
			print OUT "%%BeginDocument: " . $base . ".eps$/";
			# - copy PS data
			seek (IN,$psstrt,0);
			for ($c = $pssiz; $c >= 0x10000; $c = $c - 0x10000) {
				read (IN,$buf,0x10000);
				print (OUT $buf);
			}
			if (read (IN,$buf,$pssiz % 0x10000)) {
				print (OUT $buf);
			}
			print OUT "%%EndDocument$/";
			print OUT "grestore$/";
			# - trim mark
			if ( $addtmb ) {
				print OUT "gsave$/";
				print OUT "newpath 0 setlinecap 0 setlinejoin [] 0 setdash$/";
				if ($addtmb != 2) { #trim&bleed marks
					print OUT $TrimBoxH[2]," ",$TrimBoxH[1]," ","moveto$/";
					print OUT 25.511794953+$cstbld," 0 rmoveto$/-25.511794953 0 rlineto$/0 ",-25.511794953-$cstbld," rlineto$/";
					print OUT 0-$cstbld," 0 rmoveto$/0 25.511794953 rlineto$/",25.511794953+$cstbld," 0 rlineto$/";
					print OUT $TrimBoxH[2]," ",$TrimBoxH[3]," ","moveto$/";
					print OUT "90 rotate$/";
					print OUT 25.511794953+$cstbld," 0 rmoveto$/-25.511794953 0 rlineto$/0 ",-25.511794953-$cstbld," rlineto$/";
					print OUT 0-$cstbld," 0 rmoveto$/0 25.511794953 rlineto$/",25.511794953+$cstbld," 0 rlineto$/";
					print OUT "-90 rotate$/";
					print OUT $TrimBoxH[0]," ",$TrimBoxH[3]," ","moveto$/";
					print OUT "180 rotate$/";
					print OUT 25.511794953+$cstbld," 0 rmoveto$/-25.511794953 0 rlineto$/0 ",-25.511794953-$cstbld," rlineto$/";
					print OUT 0-$cstbld," 0 rmoveto$/0 25.511794953 rlineto$/",25.511794953+$cstbld," 0 rlineto$/";
					print OUT "-180 rotate$/";
					print OUT $TrimBoxH[0]," ",$TrimBoxH[1]," ","moveto$/";
					print OUT "270 rotate$/";
					print OUT 25.511794953+$cstbld," 0 rmoveto$/-25.511794953 0 rlineto$/0 ",-25.511794953-$cstbld," rlineto$/";
					print OUT 0-$cstbld," 0 rmoveto$/0 25.511794953 rlineto$/",25.511794953+$cstbld," 0 rlineto$/";
					print OUT "-270 rotate$/";
				}
				if ($addtmb != 1) { #center marks
					print OUT $TrimBoxH[2]+$cstbld," ",$TrimBoxH[1]+($TrimBoxH[3]-$TrimBoxH[1])/2," ","moveto$/";
					print OUT "25.511794953 0 rlineto$/";
					print OUT $TrimBoxH[2]+$cstbld+8.503931651," ",$TrimBoxH[1]+($TrimBoxH[3]-$TrimBoxH[1])/2," 7.0869 0 360 arc$/";
					print OUT $TrimBoxH[2]+$cstbld+8.503931651," ",$TrimBoxH[1]+($TrimBoxH[3]-$TrimBoxH[1])/2-34.01565," ","moveto$/";
					print OUT "0 68.0313 rlineto$/";
					print OUT $TrimBoxH[0]+($TrimBoxH[2]-$TrimBoxH[0])/2," ",$TrimBoxH[3]+$cstbld," ","moveto$/";
					print OUT "0 25.511794953 rlineto$/";
					print OUT $TrimBoxH[0]+($TrimBoxH[2]-$TrimBoxH[0])/2," ",$TrimBoxH[3]+$cstbld+8.503931651," 7.0869 90 450 arc$/";
					print OUT $TrimBoxH[0]+($TrimBoxH[2]-$TrimBoxH[0])/2-34.01565," ",$TrimBoxH[3]+$cstbld+8.503931651," ","moveto$/";
					print OUT "68.0313 0 rlineto$/";
					print OUT $TrimBoxH[0]-$cstbld," ",$TrimBoxH[1]+($TrimBoxH[3]-$TrimBoxH[1])/2," ","moveto$/";
					print OUT "-25.511794953 0 rlineto$/";
					print OUT $TrimBoxH[0]-$cstbld-8.503931651," ",$TrimBoxH[1]+($TrimBoxH[3]-$TrimBoxH[1])/2," 7.0869 0 360 arc$/";
					print OUT $TrimBoxH[0]-$cstbld-8.503931651," ",$TrimBoxH[1]+($TrimBoxH[3]-$TrimBoxH[1])/2-34.01565," ","moveto$/";
					print OUT "0 68.0313 rlineto$/";
					print OUT $TrimBoxH[0]+($TrimBoxH[2]-$TrimBoxH[0])/2," ",$TrimBoxH[1]-$cstbld," ","moveto$/";
					print OUT "0 -25.511794953 rlineto$/";
					print OUT $TrimBoxH[0]+($TrimBoxH[2]-$TrimBoxH[0])/2," ",$TrimBoxH[1]-$cstbld-8.503931651," 7.0869 90 450 arc$/";
					print OUT $TrimBoxH[0]+($TrimBoxH[2]-$TrimBoxH[0])/2-34.01565," ",$TrimBoxH[1]-$cstbld-8.503931651," ","moveto$/";
					print OUT "68.0313 0 rlineto$/";
				}
				print OUT "gsave$/";
				print OUT "1 setseparationgray$/";
				print OUT "0.5 setlinewidth$/stroke$/"; # line width 0.5pt
				print OUT "grestore$/";
				print OUT "0 setseparationgray$/";
				print OUT "0.25 setlinewidth$/stroke$/"; # line width 0.25pt
				print OUT "grestore$/";
			}
			if( $rot ) {
				$tmp = int ($rot / 90 ) * 90;
				if ($tmp == 90) { print OUT "-90 rotate$/"; }
				if ($tmp == 180) { print OUT "-180 rotate$/"; }
				if ($tmp == 270) { print OUT "-270 rotate$/"; }
			}

			print OUT "%%PageTrailer$/";
			print OUT "%%Trailer$/";

			$x1 = $cstmed;	$x2 = $width-$cstmed;
			$y1 = $cstmed;	$y2 = $hight-$cstmed;
			$mark1 = "/pdfmark where{pop[{Page1}1 dict begin ";
			$mark2 = "]def currentdict end /PUT pdfmark}if$/";
			if ($crp == 1) {
				print OUT $mark1,"/CropBox[",$x1," ",$y1," ",$x2," ",$y2,$mark2;
				print OUT $mark1,"/BleedBox[",$x1," ",$y1," ",$x2," ",$y2,$mark2;
			} elsif ($crp == 2) {
				print OUT $mark1,"/CropBox[",$x1-$cstbld," ",$y1-$cstbld," ",$x2+$cstbld," ",$y2+$cstbld,$mark2;
				print OUT $mark1,"/BleedBox[",$x1-$cstbld," ",$y1-$cstbld," ",$x2+$cstbld," ",$y2+$cstbld,$mark2;
			} else {
				print OUT $mark1,"/BleedBox[",$x1-$cstbld," ",$y1-$cstbld," ",$x2+$cstbld," ",$y2+$cstbld,$mark2;
			}
			print OUT $mark1,"/TrimBox[",$x1," ",$y1," ",$x2," ",$y2,$mark2;
			print OUT $mark1,"/MediaBox[",$x1 - $cstmed," ",$y1 - $cstmed," ",$x2 + $cstmed," ",$y2 + $cstmed,$mark2;

			print OUT "currentdict /showpage undef$/";
			print OUT "showpage$/";
			print OUT "%%EOF$/";
			close (OUT);
		}
	}
	close (IN);
}